/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _GRAPHMODEL_H_
#define _GRAPHMODEL_H_

#include<vector>

/**
 * Point on a graph
 */
class TGraphPoint {
  public:  
    double x;
    double y;
    TGraphPoint():x(0), y(0){};
    TGraphPoint(const double n_x, const double n_y):
            x(n_x),
            y(n_y){};
    TGraphPoint(const TGraphPoint& src):
            x(src.x),
            y(src.y){};
};

class TGraphSeries {
  public:
    TGraphSeries(){};
    TGraphSeries(const TGraphSeries& src):points(src.points){};
    std::vector<TGraphPoint> points;
};

/**
 * TGraphModel is the class which manages the data for the TGraphWidget.
 * The core entity of the TGraphModel is TPoint, which represents the point (X,Y)
 * on the plain. The points forms the Series. The points within the series may 
 * form the lines of any directions and complexity since they are connected just 
 * one after another sequentially.
 */
class TGraphModel
{
	public:        
		TGraphModel();
		virtual ~TGraphModel();
        std::vector<TGraphSeries> series;
	protected:
	private:
        
};


#endif	//_GRAPHMODEL_H_
